unit bufinstr;
interface
uses dos,buffile;
const
  sbipt=0;
  inspt=1;
type
  insop=record
    ksl,multi,fb,ar,sl,eg_typ,dr,rr,tl,am,vib,ksr,fm:word;
  end;
  insformat=record
    mode,nummer:byte;
    modulator,carrier:insop;
    mwafesel,cwafesel:word;
  end;
  sbiformat=record
    snd,ksltl,ardr,slrr,ws,fbfm:array[0..1] of byte;
    dummy:array[0..3] of byte;
  end;
bnktp=^bnkrc;
SBIFormatP=^SBIFormat;
insformatp=^INSformat;
insname=array[0..8] of char;
    Instp=record
      art:byte;
      case boolean of
        true:(INS:INSFormatP);
        false:(sbi:SBIFormatP);
      end;
bnkrc=record
  name:InsName;
  Ins:InsTp;
  Next:BnkTp;
end;

function loadBNK(N:string;var b:bnktp):boolean;
Procedure SucheIns(N:InsName;B:BnkTp;Var F:BnkTp);
procedure ergaenzeins(n:insname;var b:bnktp;i:instp);
procedure kopiereinS(s:INStp;var t:instp);
procedure RichtigerInsName(Var N: InsName);
procedure SBIzuINS(var i:instp);

implementation
type bytearray=array[0..52] of byte;
     wordarray=array[0..52] of word;
     bnkheader=record
       version:word;
       id:array[0..5] of char;
       nrbenutzt,nrinsgesamt:word;
       namestart,datastart:longint;
       dummy:array[0..7] of byte;
     end;
     bnkinsname=record
       indexnr:word;
       benutzt:byte;
       name:insname;
     end;
     bnkop=record
       ksl,multi,fb,ar,sl,eg_typ,dr,rr,tl,am,vib,ksr,fm:byte;
     end;
     bnkinsdata=record
       mode,nummer:byte;
       modulator,carrier:bnkop;
       mws,cws:byte;
     end;

procedure sbi2insop(var o:insop;h:sbiformat;t:byte);
begin
  with h do begin
    o.am:=(snd[t] and 128) shr 7;
    o.vib:=(snd[t] and 64) shr 6;
    o.eg_typ:=(snd[t] and 32) shr 5;
    o.ksr:=(snd[t] and 16) shr 4;
    o.multi:=snd[t] and 15;
    o.ksl:=(ksltl[t] and 129) shr 6;
    o.tl:=ksltl[t] and 63;
    o.ar:=(ardr[t] and 240) shr 4;
    o.dr:=ardr[t] and 15;
    o.sl:=(slrr[t] and 240) shr 4;
    o.rr:=slrr[t] and 15;
    o.fb:=(fbfm[t] and 14) shr 1;
    o.fm:=(fbfm[t] and 1) xor 1;
  end;
end;

procedure bytezuword(var i:insop;o:bnkop);
var p:^bytearray;
    q:^wordarray;
    t:byte;
begin
  q:=addr(I);P:=addr(O);
  for t:=0 to 13 do q^[t]:=p^[t];
end;

procedure SBIzuINS(var i:instp);
var s:insformatp;
begin
  if i.art<>inspt then begin
    new(s);
    sbi2insop(S^.modulator,i.SBI^,0);
    sbi2insop(s^.carrier,i.sbi^,1);
    s^.mwafesel:=i.sbi^.ws[0] and 3;
    s^.cwafesel:=i.sbi^.ws[1] and 3;
    s^.mode:=0;
    s^.nummer:=0;
    dispose(i.sbi);
    i.ins:=s;
    i.art:=inspt;
  end;
end;

function loadbnk(N:string;var b:bnktp):boolean;
var header:bnkheader;
    name:bnkinsname;
    data:bnkinsdata;
    namepos:longint;
    i:instp;
    f:file;
    buf:TFileBuf;
begin
  b:=nil;
  i.art:=inspt;
  new(i.ins);
  buf.reset(n,1,100);
  if doserror=0 then begin
    buf.read(header,sizeof(header));
    if header.id='ADLIB-' then begin
      namepos:=header.namestart;
      while header.nrbenutzt>0 do begin
        buf.seek(namepos);
        buf.read(name,sizeof(name));
        namepos:=buf.filepos;
        if header.nrbenutzt<>0 then begin {oder header.nrbenutzt oder name.benutzt}
          buf.seek(header.datastart+name.indexnr*sizeof(data));
          buf.read(data,sizeof(data));
          i.ins^.mode:=data.mode;
          i.ins^.nummer:=data.nummer;
          bytezuword(i.ins^.modulator,data.modulator);
          bytezuword(i.ins^.carrier,data.carrier);
          i.ins^.MWafesel:=data.mws;
          i.ins^.cwafesel:=data.cws;
          ergaenzeINS(name.name,b,i);
        end;
        dec(header.nrbenutzt)
      end
    end;
    buf.close;
    dispose(i.ins);
    loadbnk:=true;
  end else loadbnk:=false;
end;

Procedure SucheIns(N:InsName;B:BnkTp;Var F:BnkTp);
begin
  richtigerinsname(n);
  f:=b;
  while (f<>nil) and (n<>f^.name) do f:=f^.next;
end;

procedure ergaenzeins(n:insname;var b:bnktp;i:instp);
var h,q,v:bnktp;
begin
  v:=nil;
  h:=b;
  richtigerinsname(n);
  new(q);
  kopiereins(i,q^.ins);
  q^.name:=n;
  while (h<>nil) and (N>h^.name) do begin
    v:=h;
    h:=h^.next;
  end;
  if (h=nil) or (n<>h^.name) then begin
    q^.next:=h;
    if v<>nil then v^.next:=q else b:=q;
  end;
end;

procedure kopiereins(s:INStp;var t:instp);
begin
  if s.art=inspt then begin
    new(t.ins);
    t.ins^:=s.ins^;
    t.art:=inspt;
  end else begin
    new(t.sbi);
    t.sbi^:=s.sbi^;
    t.art:=sbipt;
  end;
end;

procedure RichtigerInsName(Var N: InsName);
var i:byte;
begin
  i:=0;
  while (i<9) and (n[i]<>#0) do begin
    n[i]:=upcase(n[i]);
    inc(i);
  end;
  while (i<9) do begin
    n[i]:=#0;
    inc(i);
  end;
end;

end.