unit bufrol;
interface
uses crt,bufinstr,buffile;
const verarbeiteevents=100;
type
  insevrc=record
    zeit:word;
    ins:insname;
    dummy:array[0..2] of byte;
  end;
  multevrc=record
    zeit:word;
    mult:single;
  end;
  noteevrc=record
    ton:integer;
    zeit:word;
  end;
  noteevs=record
    anzahl:word;
    e:array[1..1] of noteevrc;
  end;
  insevs=record
    anzahl:word;
    e:array[1..1] of insevrc;
  end;
  multevs=record
    anzahl:word;
    e:array[1..1] of multevrc;
  end;
  noteevpt=^noteevs;
  multevpt=^multevs;
  insevpt=^insevs;
  kanalrc=record
    verwendet:boolean;
    notet,noteo,inso,volo,tonhoeheo:word;
    noteev:noteevpt;
    insev:insevpt;
    volev,tonhoeheev:multevpt;
  end;
  roltp=record
    grundtempo:single;
    modus,nrkanaele,taktbeat,tempoo:word;
    tempoev:multevpt;
    kanal:array[0..10] of ^kanalrc;
  end;

var sndioresult:word;
function ueberpruefeSNDTreiber:boolean;
procedure loadrol(n:string;var r:roltp);
procedure entfernerol(var r:roltp);
procedure spielerol(var r:roltp;b:bnktp);
procedure resetsounddrv;
procedure callsound(f,p0,p1,p2,p3,p4:integer);

implementation

uses dos;
const sndintr=101;
type eventliste=(tempoeve,voleve,inseve,noteeve,tonhoeheeve,keineve);
     rolheader=record
       majversion,minversion:word;
       dummy0:array[0..39] of char;
       uhrbeat,beatsecond,yscale,xscale:word;
       dummy1:byte;
       abspielmodus:byte;
       dummy2:array[0..142] of byte;
       grundtempo:single;
     end;
     testheader=record
       version:word;
       id:array[0..18] of char;
       dummy:array[0..2] of byte;
     end;
var sdiv:word;
    bank:bnktp;

function ueberpruefeSNDtreiber:boolean;
var p:^testHeader;
    q:pointer;
begin
  getintvec(SNDIntr,q);
  p:=ptr(seg(q^),ofs(q^)-sizeof(testheader));
  sndioresult:=p^.version;
  ueberpruefesndtreiber:=p^.id='SOUND-DRIVER-AD-LIB';
end;

procedure callsound(f,p0,p1,p2,p3,p4:integer);
var
  r:registers;
  a:array[0..4] of integer;
begin
  a[0]:=p0;a[1]:=p1;a[2]:=p2;a[3]:=p3;a[4]:=p4;
  r.si:=f;
  r.es:=seg(a);
  r.bx:=ofs(a);
  intr(sndintr,r);
  sndioresult:=r.al;
end;

procedure tempoevent(t:word;b,f:single);
begin
  callsound(9,trunc(b*f),t,sdiv,10,10);
end;

procedure loadrol(n:string;var r:roltp);
var buf:Tfilebuf;

  procedure liesmultevents(var n:multevpt);
  var s,anzahl:word;
  begin
    s:=sizeof(multevrc);
    buf.read(anzahl,2);
    getmem(n,2+anzahl*S);
    n^.anzahl:=anzahl;
    buf.read(n^.e,anzahl*S);
  end;

  procedure liesInsEvents(var n:insevpt);
  var s,anzahl:word;
  begin
    s:=sizeof(insevrc);
    buf.read(anzahl,2);
    getmem(n,2+anzahl*s);
    n^.anzahl:=anzahl;
    buf.read(n^.e,anzahl*s);
  end;

  procedure liesnoteevents(var n:noteevpt);
  var s,insgesamt,summe,laenge,anzahl:word;
      start:longint;
  begin
    s:=sizeof(noteevrc);
    buf.read(insgesamt,2);
    start:=buf.filepos;
    summe:=0;
    anzahl:=0;
    while summe<insgesamt do begin
      buf.seek(buf.filepos+2);
      buf.read(laenge,2);
      summe:=summe+laenge;
      inc(anzahl);
    end;
    buf.seek(start);
    getmem(n,2+anzahl*s);
    n^.anzahl:=anzahl;
    buf.read(n^.e,anzahl*s);
  end;

var header:rolheader;
    anzahl:word;
    maxkanal:byte;
    k:byte;
    ext:extstr;
    dir:dirstr;
begin
  fsplit(n,dir,n,ext);
  buf.reset(dir+n+'.ROL',1,100);
  buf.read(header,sizeof(header));
  r.grundtempo:=header.grundtempo;
  r.modus:=header.abspielmodus;
  r.taktbeat:=header.uhrbeat;
  if r.modus=1 then r.NrKanaele:=8 else r.nrkanaele:=10;
  liesmultevents(r.tempoev);
  for k:=0 to r.nrkanaele do begin
    new(r.kanal[k]);
    with r.kanal[k]^ do begin
      buf.seek(buf.filepos+15);
      liesnoteevents(noteev);
      buf.seek(buf.filepos+15);
      liesinsevents(insev);
      buf.seek(buf.filepos+15);
      liesmultevents(volev);
      buf.seek(buf.filepos+15);
      liesmultevents(tonhoeheev);
      verwendet:=noteev^.anzahl>0;
    end;
  end;
  buf.close;
end;

procedure entfernerol(var r:roltp);
var k:byte;
begin
  for k:=0 to r.nrkanaele do begin
    with r.kanal[k]^ do begin
      freemem(noteev,2+noteev^.anzahl*sizeof(noteevrc));
      freemem(insev,2+insev^.anzahl*sizeof(insevrc));
      freemem(tonhoeheev,2+tonhoeheev^.anzahl*sizeof(multevrc));
      freemem(Volev,2+Volev^.anzahl*sizeof(multevrc));
    end;
    dispose(r.kanal[k]);
  end;
  freemem(r.tempoev,2+r.tempoev^.anzahl*sizeof(multevrc));
end;

procedure tonevent(k,t,s,h:integer);
begin
  callsound(12,k,0,0,0,0);
  if h<>0 then
    if s<>0 then
      callsound(14,h-60,t,sdiv,t+s,sdiv)
    else
      callsound(15,h-60,t,sdiv,0,0)
  else
    callsound(14,h-60,0,sdiv,t,sdiv);
end;

procedure volevent(k,t:word;f:single);
begin
  callsound(12,k,0,0,0,0);
  callsound(8,trunc(f*255),255,t,sdiv,0);
end;

procedure tonhoeheevent(k,t:word;f:single);
begin
  callsound(12,k,0,0,0,0);
  callsound(17,0,trunc(f*255),255,t,sdiv);
end;

procedure insevent(k,t:word;i:InsName);
var b:bnktp;
begin
  richtigerinsname(i);
  sucheins(i,bank,b);
  if b<>nil then begin
    sbizuins(b^.ins);
    callsound(12,k,0,0,0,0);
    callsound(16,ofs(b^.ins.ins^.modulator),seg(b^.ins.ins^.modulator),t,sdiv,0);
  end;
end;


procedure resetrol(var r:roltp);
var k:byte;
begin
  for k:=0 to r.nrkanaele do
    with r.kanal[k]^ do begin
      notet:=0;
      noteo:=1;
      inso:=1;
      volo:=1;
      tonhoeheo:=1;
    end;
  r.tempoo:=1;
end;

function gibev(var r:roltp;k:byte;e:eventliste):word;
var h:word;
begin
  h:=$FFFF;
  if e<>tempoEve then
    with r.kanal[k]^ do
      case e of
      voleve:if volo<=volev^.anzahl then h:=volev^.e[volo].zeit;
      inseve:if inso<=insev^.anzahl then h:=insev^.e[inso].zeit;
      tonhoeheeve:if TonHoeheo<=TonHoeheev^.anzahl then h:=TonHoeheev^.e[TonHoeheo].zeit;
      Noteeve:if Noteo<=Noteev^.anzahl then h:=Noteev^.e[Noteo].zeit;
    end
  else
   if r.tempoo<>r.tempoev^.anzahl then h:=r.tempoev^.e[r.tempoo].zeit;
   gibev:=h;
end;

procedure suchenaechstev(var r:roltp;var k:byte;var e:eventliste);
var t:byte;
  h:eventliste;
  g:word;
begin
  e:=keineve;
  g:=gibev(r,0,tempoeve);
  if g<$FFFF then e:=tempoeve;
  for t:=0 to r.nrkanaele do
    if r.kanal[t]^.verwendet then
      for h:=voleve to tonhoeheeve do
        if g>gibev(r,t,h) then begin
          g:=gibev(r,t,h);
          e:=h;
          k:=t;
        end;
end;

procedure stelleeventein(var r:roltp;k:byte;e:eventliste);
begin
  if e<>tempoeve then
    with r.kanal[k]^ do
      case e of
        voleve: with volev^.e[volo] do volevent(k,zeit,mult);
        Inseve: with Insev^.e[Inso] do Insevent(k,zeit,ins);
        Noteeve: with Noteev^ do
          if e[noteo+1].ton<>0 then
            with e[noteo] do tonevent(k,zeit,0,ton)
          else
            with noteev^ do
              tonevent(k,e[noteo].zeit,e[noteo+1].zeit,e[noteo].ton);
        TonHoeheeve: with TonHoeheev^.e[TonHoeheo] do TonHoeheevent(k,zeit,mult);
      end
   else
     with r.tempoev^.e[r.tempoo] do
       tempoevent(zeit,r.grundtempo,mult);
end;

procedure erhoeheev(var r:roltp;k:byte;e:eventliste);
begin
  if e<>tempoeve then
    with r.kanal[k]^ do
      case e of
        voleve:inc(volo);
        inseve:inc(inso);
        noteeve:with noteev^ do begin
          inc(notet,e[noteo].zeit);
          inc(noteo);
          if e[noteo].ton=0 then
          begin
            inc(notet,e[noteo].zeit);
            inc(noteo);
          end;
        end;
        tonhoeheeve: inc(tonhoeheo);
      end
    else inc(r.tempoo);
end;

procedure spielerol(var r:roltp;b:bnktp);
var event:eventliste;
  kanal:byte;
  zaehler:word;
begin
  bank:=b;
  callsound(2,0,1,0,0,0);
  callsound(5,0,0,0,0,0);
  callsound(6,r.modus xor 1,0,0,0,0);
  callsound(18,r.taktbeat,0,0,0,0);
  tempoevent(0,r.grundtempo,1);
  sdiv:=r.taktbeat;
  resetrol(r);
  zaehler:=0;
  repeat
    suchenaechstev(r,kanal,event);
    stelleeventein(r,kanal,event);
    if sndioresult<>0 then
      erhoeheev(r,kanal,event);
    inc(zaehler);
  until (SNDIOResult=0) or (event=keineve) or (zaehler>verarbeiteevents);
  callsound(3,1,0,0,0,0);
  while (event<>keineve) and (not keypressed) do begin
    repeat
      stelleeventein(r,kanal,event);
    until (sndioresult<>0) or keypressed;
    erhoeheev(r,kanal,event);
    suchenaechstev(r,kanal,event);
  end;
end;

procedure resetsounddrv;
begin
  callsound(0,0,0,0,0,0);
end;

end.
