unit cmsunit;
interface
const data:word=$220;
      on=true;
      off=false;

procedure cmsinit;
procedure cms(x:boolean); {an aus}              {1<=stimme<=12}
procedure cmsbalance(stimme,links,rechts:byte); {balance}
procedure cmsstimme(stimme:byte;x:boolean); {stimme an aus}
procedure cmsfrequenz(stimme:byte;frequenz:word); {stimme hhe}
procedure cmsrauschen(stimme:byte;x:boolean); {stimme rauschen}
procedure cmsrauschart(stimme,art:byte); {stimme rauschart}

implementation
const stimme1:byte=0;
      stimme2:byte=0;
      rauschen1:byte=0;
      rauschen2:byte=0;
      art1:byte=0;
      art2:byte=0;
type hifrequenztyp=array[0..5] of byte;
var hifrequ:hifrequenztyp;
    z:byte;

procedure cms1out(reg,out:byte);
var n,h:byte;
begin
  port[succ(data)]:=reg;
  port[data]:=out;
end;

procedure cms2out(reg,out:byte);
var n,h:byte;
begin
  port[data+3]:=reg;
  port[data+2]:=out;
end;

procedure cms(x:boolean);
begin
  cms1out($1c,byte(x));
  cms2out($1c,byte(x));
end;

procedure cmsbalance(stimme,links,rechts:byte);
begin
  if (stimme<13) or (stimme>0) then begin
    if stimme<7 then cms1out(pred(stimme),links*16+rechts)
    else cms2out(stimme-7,links*16+rechts);
  end;
end;

procedure cmsstimme(stimme:byte;x:boolean);
begin
  if (stimme<13) or (stimme>0) then begin
    if stimme<7 then begin
      stimme1:=(stimme1 and ($FF xor (1 shl pred(stimme)))) or (byte(x) shl pred(stimme));
      cms1out($14,stimme1)
    end else begin
      stimme2:=(stimme2 and ($FF xor (1 shl (stimme-7)))) or (byte(x) shl (stimme-7));
      cms2out($14,stimme2)
    end;
  end;
end;

procedure cmsrauschen(stimme:byte;x:boolean);
begin
  if (stimme<13) or (stimme>0) then begin
    if stimme<7 then begin
      rauschen1:=(rauschen1 and ($FF xor (1 shl pred(stimme)))) or (byte(x) shl pred(stimme));
      cms1out($15,rauschen1)
    end else begin
      rauschen2:=(rauschen2 and ($FF xor (1 shl (stimme-7)))) or (byte(x) shl (stimme-7));
      cms2out($15,rauschen2)
    end;
  end;
end;

procedure cmsfrequenz(stimme:byte;frequenz:word);
begin
  if (stimme<13) or (stimme>0) then begin
    if stimme<7 then begin
      cms1out(7+stimme,lo(frequenz));
      hifrequ[pred(stimme) div 2]:=(hifrequ[pred(stimme) div 2] and
      ($f0 shr (4*(pred(stimme) and 1)))) or
      (((hi(frequenz) and $07) shl (4*(pred(stimme) and 1))));
      cms1out(pred(stimme) div 2 +$10,hifrequ[pred(stimme) div 2]);
    end else begin
      cms2out(1+stimme,lo(frequenz));
      hifrequ[pred(stimme) div 2]:=(hifrequ[pred(stimme) div 2] and
      ($f0 shr (4*(pred(stimme) and 1)))) or
      (((hi(frequenz) and $07) shl (4*(pred(stimme) and 1))));
      cms2out((stimme-7) div 2 +$10,hifrequ[pred(stimme) div 2]);
    end;
  end;
end;

procedure cmsrauschart(stimme,art:byte);
begin
  if (stimme<13) or (stimme>0) then begin
    if stimme<3 then begin
      art1:=(art1 and $F0) or (art and 3);
      cms1out($16,art1);
    end else if stimme<6 then begin
      art1:=(art1 and $0f) or ((art and 3) shl 4);
      cms1out($16,art1);
    end else if stimme<9 then begin
      art2:=(art2 and $F0) or (art and 3);
      cms2out($16,art2);
    end else begin
      art2:=(art2 and $0f) or ((art and 3) shl 4);
      cms2out($16,art2);
    end;
  end;
end;

procedure cmsinit;
begin
  cms1out($14,0);
  cms2out($14,0);
  cms1out($15,0);
  cms2out($15,0);
  cms(on);
  for z:=$10 to $12 do begin
    cms1out(z,0);
    cms2out(z,0);
  end;
  for z:=$08 to $0d do begin
    cms1out(z,0);
    cms2out(z,0);
  end;
  fillchar(hifrequ,6,0);
  cms1out($16,0);
  cms2out($16,0);
end;

end.