unit vga;
interface
uses dos;
Type PPalette=^TPalette;
     TPalette=array[0..255,0..2] of byte;
var seite:byte;

procedure videomodus(modus:byte);
function videomoduslesen:byte;
procedure plot(x,y:word;farbe:byte);
function getpixel(x,y:word):byte;
procedure farbe(register:word;rot,gruen,blau:byte);
procedure lesefarbe(register:word;var r,g,b:byte);
procedure map(mask:byte);
procedure readmap(nummer:byte);
procedure color(mask:byte);
procedure videoseite(neueseite:byte);
procedure vgaende;
procedure scqmode;
procedure scqplot(x,y:integer;color:byte);
function scqgetpixel(x,y:integer):byte;
procedure ladetextromzs(block:byte);
procedure vgaleseseite(seite:byte);
procedure vgaschreibeseiten(seiten:byte);
procedure waitsync;
procedure farbblock(anfang,anzahl:word;block:PPalette);
procedure farbblocklesen(anfang,anzahl:word;block:PPalette);
procedure farbblockshade(anfang,anzahl:word;block:PPalette;anztrick:word);
procedure farbshade(anfang,anzahl:word;block:PPalette);
procedure overscan(c:byte);
procedure shadein(x:byte;pal:ppalette);
procedure shadeout(x:byte;pal:ppalette);

implementation

var regs:registers;
    altseite,altmodus:byte;
    oldexitproc:pointer;

{$F+}
procedure myownexitproc;
begin
  vgaende;
  exitproc:=oldexitproc;
end;
{$f-}

procedure videomodus(modus:byte);
begin
  with regs do begin
    ah:=0;al:=modus;intr($10,regs);
    seite:=1;
  end;
end;

function videomoduslesen:byte;
begin
  with regs do begin
    ah:=$0f;intr($10,regs);
    seite:=bh;videomoduslesen:=al;
  end;
end;

procedure plot(x,y:word;farbe:byte);
begin
  mem[$A000:x+320*y]:=farbe;
{  with regs do begin
    ah:=$0c;al:=farbe;cx:=x;dx:=y;bh:=seite;intr($10,regs);
  end}
end;

function getpixel(x,y:word):byte;
begin
  getpixel:=mem[$A000:x+320*y];
end;
procedure farbe(register:word;rot,gruen,blau:byte);
begin
  with regs do begin
    ax:=$1010;bx:=register;ch:=gruen;cl:=blau;dh:=rot;intr($10,regs);
  end;
end;

procedure lesefarbe(register:word;var r,g,b:byte);
begin
  with regs do begin
    ax:=$1015;bx:=register;intr($10,regs);g:=ch;b:=cl;r:=dh;
  end;
end;

procedure map(mask:byte);
begin
  port[$3c4]:=2;
  port[$3c5]:=mask;
end;

procedure color(mask:byte);
begin
  port[$3ce]:=0;
  port[$3cf]:=mask;
end;

procedure readmap(nummer:byte);
begin
  port[$3ce]:=4;
  port[$3cf]:=nummer and 3;
end;

procedure videoseite(neueseite:byte);
begin
  with regs do begin
    seite:=neueseite;
    ah:=$05;al:=neueseite;intr($10,regs);
  end;
end;

procedure vgaleseseite(seite:byte);
begin
  port[$3ce]:=4;
  port[$3cf]:=seite and 3;
end;

procedure vgaschreibeseiten(seiten:byte);
begin
  port[$3c4]:=2;
  port[$3c5]:=seiten and $0f;
end;

procedure vgaende;
begin
  videomodus(altmodus);
  videoseite(altseite);
end;

procedure scqmode;
const reg_wert:array[0..$17] of byte=
      ($6b,$59,$5a,$8e,$5e,$8a,$0d,$3e,
       $ff,$40,$ff,$ff,$ff,$ff,$ff,$ff,
       $ea,$ac,$df,$2d,$00,$e7,$06,$e3);
var lese,zaehler:byte;
begin
  videomodus($12);
  videomodus($13);
  port[$3c4]:=4;
  port[$3c5]:=6;
  port[$3c4]:=0;
  port[$3c5]:=1;
  port[$3c2]:=$e7;
  port[$3c4]:=0;
  port[$3c5]:=3;
  port[$3d4]:=$11;
  lese:=(port[$3d5] and $7f);
  port[$3d5]:=lese;
  for zaehler:=0 to $17 do begin
    if reg_wert[zaehler]<>$FF then begin
      port[$3d4]:=zaehler;
      port[$3d5]:=reg_wert[zaehler];
    end;
  end;
end;

procedure scqplot(x,y:integer;color:byte);
begin
  if ((x>=0) and (y>=0) and (x<360) and (y<480)) then begin
{$r-}
    port[$03c4]:=2;
    port[$03c5]:=1 shl (x and 3);
    mem[$a000:y*90+ (x shr 2)]:=color; {$r+}
  end;
end;

function scqgetpixel(x,y:integer):byte;
begin
{$r-}
  port[$03cE]:=4;
  port[$03cf]:=x and 3;
  scqgetpixel:=mem[$a000:y*90+ (x shr 2)];
{$r+}
end;

procedure ladetextromzs(block:byte);
begin
  with regs do begin
    ax:=$1104;bl:=block;
    intr($10,regs);
  end;
end;

procedure waitsync;
begin
  asm
         mov  dx,$3da
         mov  ah,8
{  @wait2:in   al,dx
         test al,ah
         jnz  @wait2}
  @wait4:in   al,dx
         test al,ah
         jz   @wait4
  end;
end;

procedure farbblock(anfang,anzahl:word;block:PPalette);
{var regs:registers;}
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang;
   mov cx,anzahl;
   mov ds,segb;
   mov si,ofsb;
   CLD
   mov  dx,$3da
   mov  ah,8
@wait:in al,dx
   test al,ah
   jz  @wait
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX

@1:LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL
   LODSB
   OUT	DX,AL
   LOOPNZ @1

   STI
   POP	DS
  end;
{  with regs do begin
    ax:=$1012;
    bx:=anfang;
    cx:=anzahl;
    es:=seg(block^);
    dx:=ofs(block^);
    intr($10,regs);
  end;        }
end;

procedure farbblockshade(anfang,anzahl:word;block:PPalette;anztrick:word);
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang
   mov cx,anzahl
   mov ax,anztrick
   sub cx,ax
   mov ds,segb
   mov si,ofsb
   CLD
   mov  dx,$3da
   mov  ah,8
@wait:in al,dx
   test al,ah
   jz  @wait
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX

@1:LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL
   LODSB
   OUT	DX,AL
   LOOPNZ @1

   mov cx,anztrick
@2:
   LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL

   MOV DX,$03DA
@WAIT1: IN AL,DX
   TEST AL,1
   JNZ @WAIT1
@WAIT2: IN AL,DX
   TEST AL,1
   JZ @WAIT2
   MOV DX,$3C9

   LODSB
   OUT	DX,AL
   LOOPNZ @2

   STI
   POP	DS
  end;
end;

procedure farbshade(anfang,anzahl:word;block:PPalette);
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang;
   mov cx,anzahl;
   mov ds,segb;
   mov si,ofsb;
   CLD
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX
@2:
   LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL

   MOV DX,$03DA
@WAIT1: IN AL,DX
   TEST AL,1
   JNZ @WAIT1
@WAIT2: IN AL,DX
   TEST AL,1
   JZ @WAIT2
   MOV DX,$3C9

   LODSB
   OUT	DX,AL
   LOOPNZ @2

   STI
   POP	DS
  end;
end;

procedure farbblocklesen(anfang,anzahl:word;block:PPalette);
var regs:registers;
begin
  with regs do begin
    ax:=$1017;
    bx:=anfang;
    cx:=anzahl;
    es:=seg(block^);
    dx:=ofs(block^);
    intr($10,regs);
  end;
end;

procedure overscan(c:byte);
var regs:registers;
begin
  with regs do begin
    ax:=$1001;
    bh:=c;
    intr($10,regs);
  end;
end;

procedure shadein(x:byte;pal:ppalette);
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=1 to 32 do begin
    for c:=x to 255 do for r:=0 to 2 do aktpal[c-x,r]:=byte(word(pal^[c,r])*word(n) div 32);
    farbblockshade(x,256-x,@aktpal,250-x);
  end;
end;

procedure shadeout(x:byte;pal:ppalette);
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=32 downto 0 do begin
    for c:=x to 255 do for r:=0 to 2 do aktpal[c-x,r]:=byte(word(pal^[c,r])*word(n) div 32);
    farbblockshade(x,256-x,@aktpal,250-x);
  end;
end;

begin
  altmodus:=videomoduslesen;
  altseite:=seite;
  oldexitproc:=exitproc;
  exitproc:=@myownexitproc;
end.